module instmem(subclk, pc, ir);
   input subclk;	// should be ~clk: memory ops exec at down side of clk
   input [15:0] pc;
   output [15:0] ir;

   altsyncram inst_rom(
		       .address_a(pc[7:0]),
		       .clock0(subclk),
		       .q_a(ir)
		       );
   defparam
     inst_rom.operation_mode = "SINGLE_PORT",
     inst_rom.width_a = 16,
     inst_rom.widthad_a = 8,
     inst_rom.lpm_hint = "ENABLE_RUNTIME_MOD=YES, INSTANCE_NAME=inst_rom",
     inst_rom.init_file = "inst_contains.mif";

endmodule // instmem
