module irq(rst, clk, irq, irq_stage1, irq_stage2, irq_done);
   input  rst, clk;
   input  irq;		// interrupt
   output irq_stage1;	// the previous cycle has irq
   reg    irq_stage1;
   output irq_stage2;	// the previous previous cycle has irq
   reg    irq_stage2;
   output irq_done;	// irq is finished
   reg	  irq_done;

   // irq: input signal (async)
   // irq_stage1: push stack: PC = M[R6], R6--
   // irq_stage2: read irq addr: wd = M[0x40]
   // irq_done: PC <= wd
   always@(posedge clk or negedge rst)
     begin
       if (~rst)
         begin
         irq_stage1 <= 0;
	 irq_stage2 <= 0;
	 irq_done <= 0;
	 end
       else
	 begin
         irq_stage1 <= irq;
	 irq_stage2 <= irq_stage1;
	 irq_done <= irq_stage2;
	 end
     end
endmodule // irq
