module stage_exec(state, rd1, rd2, wd, apsr);
   input [65:0]	 state;
   input [15:0]  rd1;
   input [15:0]  rd2;
   output [15:0] wd;
   output [4:0]  apsr;  // APSR from ALU (may not be used)

   wire 	 c_sr1, c_sr2;
   wire [15:0] 	 imm, pc, op1, op2;
   wire [2:0] 	 alu_ops;

   assign op1 = c_sr1 ? rd1 : pc;
   assign op2 = c_sr2 ? rd2 : imm;

   state_unpack su_i(.state(state),
		     .imm(imm),
		     .pc(pc),
		     .c_sr1(c_sr1),
		     .c_sr2(c_sr2),
		     .alu_ops(alu_ops));

   alu alu_i(.di1(op1),
	     .di2(op2),
	     .dout(wd),
	     .alu_ops(alu_ops),
	     .apsr(apsr));

endmodule // stage_exec
